(* CSL with Barriers, v0.1
 * 
 * It is our intention to release the files under a BSD-style license shortly
 * after some badly-needed cleanup work,  
 * 
 * Until then:
 * (c) 2010 Aquinas Hobor, Cristian Gherghina, and Christopher Chak
 * All Rights Reserved
 *
 * Permission granted to use these proof scripts only for the purpose of 
 * evaluating "Barriers in Concurrent Separation Logic."
 *)

Require Import SLB_Base.
Require Import SLB_Lang.
Require Import SLB_BarDefs.
Require Import SLB_CLang.

Program Definition fst_share :=  mk_pshare  (fst (Share.split pfullshare)) _.
Next Obligation.
intro.
remember (Share.split pfullshare).
destruct p.
symmetry in Heqp.
apply Share.split_nontrivial in Heqp.
apply top_share_nonidentity.
trivial.
auto.
Qed.

Program Definition snd_share := mk_pshare  (snd (Share.split pfullshare)) _.
Next Obligation.
intro.
remember (Share.split pfullshare).
destruct p.
symmetry in Heqp.
apply Share.split_nontrivial in Heqp.
apply top_share_nonidentity.
trivial.
auto.
Qed.

Lemma fstsndfull : pjoin fst_share snd_share pfullshare.
Proof.
  unfold pjoin.
  simpl.
  remember (Share.split Share.top).
  destruct p.
  simpl.
  apply Share.split_join.
  auto.
Qed.

Definition mv01_pps: list (assert*assert) := 
(
 sepconj
     (points2 (expConst (V_addr 4)) fst_share (expConst  (V_data 0)))
 ( sepconj
     (points2 (expConst (V_addr 3)) fst_share (expConst (V_data 0)))
  (sepconj
     (points2 (expConst (V_addr 2)) fst_share (expConst (V_data 0)))
  (sepconj 
     (points2 (expConst (V_addr 1)) fst_share (expConst (V_data 0)))
     (barrier_assert  1 fst_share 0 ))))  ,
  sepconj
     (points2 (expConst (V_addr 4)) fst_share (expConst (V_data 0)))
  (sepconj
     (points2 (expConst (V_addr 3)) fst_share (expConst (V_data 0)))
  (sepconj 
     (points2 (expConst (V_addr 1)) pfullshare (expConst (V_data 0)))
     (barrier_assert  1 fst_share 1 ) )))::
(
 sepconj
     (points2 (expConst (V_addr 4)) snd_share (expConst (V_data 0)))
  (sepconj
     (points2 (expConst (V_addr 3)) snd_share (expConst (V_data 0)))
  (sepconj
     (points2 (expConst (V_addr 2)) snd_share (expConst (V_data 0)))
  (sepconj 
     (points2 (expConst (V_addr 1)) snd_share (expConst (V_data 0)))
     (barrier_assert  1 snd_share 0 ))))  ,
  (sepconj
     (points2 (expConst (V_addr 4)) snd_share (expConst (V_data 0)))
  (sepconj
     (points2 (expConst (V_addr 3)) snd_share (expConst (V_data 0)))
  (sepconj 
     (points2 (expConst (V_addr 2)) pfullshare (expConst (V_data 0)))
     (barrier_assert  1 snd_share 1 ) ))))::nil.

Definition mv03_pps: list (assert*assert) := 
(
 sepconj
     (points2 (expConst (V_addr 4)) fst_share (expConst  (V_data 1)))
 ( sepconj
     (points2 (expConst (V_addr 3)) fst_share (expConst (V_data 0)))
  (sepconj
     (points2 (expConst (V_addr 2)) fst_share (expConst (V_data 0)))
  (sepconj 
     (points2 (expConst (V_addr 1)) fst_share (expConst (V_data 0)))
     (barrier_assert  1 fst_share 0 ))))  ,
  sepconj
     (points2 (expConst (V_addr 4)) fst_share (expConst (V_data 1)))
  (sepconj
     (points2 (expConst (V_addr 3)) fst_share (expConst (V_data 0)))
  (sepconj 
     (points2 (expConst (V_addr 1)) pfullshare (expConst (V_data 0)))
     (barrier_assert  1 fst_share 3 ) )))::
(
 sepconj
     (points2 (expConst (V_addr 4)) snd_share (expConst (V_data 1)))
  (sepconj
     (points2 (expConst (V_addr 3)) snd_share (expConst (V_data 0)))
  (sepconj
     (points2 (expConst (V_addr 2)) snd_share (expConst (V_data 0)))
  (sepconj 
     (points2 (expConst (V_addr 1)) snd_share (expConst (V_data 0)))
     (barrier_assert  1 snd_share 0 ))))  ,
  (sepconj
     (points2 (expConst (V_addr 4)) snd_share (expConst (V_data 1)))
  (sepconj
     (points2 (expConst (V_addr 3)) snd_share (expConst (V_data 0)))
  (sepconj 
     (points2 (expConst (V_addr 2)) pfullshare (expConst (V_data 0)))
     (barrier_assert  1 snd_share 3 ) ))))::nil.

Definition mv12_pps: list (assert*assert) := 
  (sepconj
     (points2 (expConst (V_addr 4)) fst_share (expConst (V_data 0)))
  (sepconj
     (points2 (expConst (V_addr 3)) fst_share (expConst (V_data 0)))
  (sepconj 
     (points2 (expConst (V_addr 1)) pfullshare (expConst (V_data 0)))
     (barrier_assert  1 fst_share 1 ) )),
  (sepconj
     (points2 (expConst (V_addr 1)) fst_share (expConst (V_data 0)))
  (sepconj
     (points2 (expConst (V_addr 2)) fst_share (expConst (V_data 0)))
  (sepconj 
     (points2 (expConst (V_addr 3)) pfullshare (expConst (V_data 0)))
     (barrier_assert  1 fst_share 2 ) ))))::
  (sepconj
     (points2 (expConst (V_addr 4)) snd_share (expConst (V_data 0)))
  (sepconj
     (points2 (expConst (V_addr 3)) snd_share (expConst (V_data 0)))
  (sepconj 
     (points2 (expConst (V_addr 2)) pfullshare (expConst (V_data 0)))
     (barrier_assert  1 snd_share 1 ) )),
  sepconj
     (points2 (expConst (V_addr 1)) snd_share (expConst (V_data 0)))
  (sepconj
     (points2 (expConst (V_addr 2)) snd_share (expConst (V_data 0)))
  (sepconj 
     (points2 (expConst (V_addr 4)) pfullshare (expConst (V_data 0)))
     (barrier_assert  1 snd_share 2 ) )))::nil.

Definition mv21_pps: list (assert*assert) := 
  (sepconj
     (points2 (expConst (V_addr 1)) fst_share (expConst (V_data 0)))
  (sepconj
     (points2 (expConst (V_addr 2)) fst_share (expConst (V_data 0)))
  (sepconj 
     (points2 (expConst (V_addr 3)) pfullshare (expConst (V_data 0)))
     (barrier_assert  1 fst_share 2 ) )),
  (sepconj
     (points2 (expConst (V_addr 4)) fst_share (expConst (V_data 0)))
  (sepconj
     (points2 (expConst (V_addr 3)) fst_share (expConst (V_data 0)))
  (sepconj 
     (points2 (expConst (V_addr 1)) pfullshare (expConst (V_data 0)))
     (barrier_assert  1 fst_share 1 ) ))))::
  (sepconj
     (points2 (expConst (V_addr 1)) snd_share (expConst (V_data 0)))
  (sepconj
     (points2 (expConst (V_addr 2)) snd_share (expConst (V_data 0)))
  (sepconj 
     (points2 (expConst (V_addr 4)) pfullshare (expConst (V_data 0)))
     (barrier_assert  1 snd_share 2 ) )),
  sepconj
     (points2 (expConst (V_addr 4)) snd_share (expConst (V_data 0)))
  (sepconj
     (points2 (expConst (V_addr 3)) snd_share (expConst (V_data 0)))
  (sepconj 
     (points2 (expConst (V_addr 2)) pfullshare (expConst (V_data 0)))
     (barrier_assert  1 snd_share 1 ) )))::nil.

Program Definition mv01: BarMoveList := barMoveList  1 1 0 mv01_pps 2 _.
Next Obligation.
   unfold moves_wf.
   split;simpl.
   repeat intro.
   unfold mv01_pps in H.
   LEM (n=0).
   subst n.
   inversion H;subst.
   clear H.
   split.
 
   (*ubi P*)
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_barrier_assert.

 (*ubi Q*)
   split.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_barrier_assert.

  (*precise P *)
   split.
   apply precise_sep. apply precise_points2.
   apply precise_sep. apply precise_points2.
   apply precise_sep. apply precise_points2.
   apply precise_sep. apply precise_points2.

   apply precise_barrier.
  
  exists fst_share.
  repeat intro.
  rewrite  <- sc_assoc in H.
  rewrite sc_comm in H.
  do 3 destruct H.
  destruct H0.
  rewrite  <- sc_assoc in H0.
  rewrite sc_comm in H0.
  do 3 destruct H0.
  destruct H2.
  exists x1. 
  destruct (join_assoc _ _ _ _ _ H0 H) as [? [? ?]].
  exists x3.
  split; trivial.
  split; trivial.
  unfold Tru; trivial.

  LEM (n=1).
  (*second case *)
   subst n.
   clear H0.
   inversion H;subst.
   clear H.
   split.
 
 (*ubi P*)
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_barrier_assert.

 (*ubi Q*)
   split.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_barrier_assert.

  (*precise P *)
   split.
   apply precise_sep. apply precise_points2.
   apply precise_sep. apply precise_points2.
   apply precise_sep. apply precise_points2.
   apply precise_sep. apply precise_points2.

   apply precise_barrier.
  
  exists snd_share.
  repeat intro.
  rewrite  <- sc_assoc in H.
  rewrite sc_comm in H.
  do 3 destruct H.
  destruct H0.
  rewrite  <- sc_assoc in H0.
  rewrite sc_comm in H0.
  do 3 destruct H0.
  destruct H2.
  exists x1. 
  destruct (join_assoc _ _ _ _ _ H0 H) as [? [? ?]].
  exists x3.
  split; trivial.
  split; trivial.
  unfold Tru; trivial.
  (*by contradiction*)
  assert (n>1) by omega.
  elimtype False.
  apply nth_error_bound in H.
  simpl in H.
  omega.

  split;trivial.
  exists
      (sepconj
         (points2 (expConst (V_addr 4)) fst_share (expConst  (V_data 0)))
      (sepconj
         (points2 (expConst (V_addr 3)) fst_share (expConst (V_data 0)))
      (sepconj
         (points2 (expConst (V_addr 2)) fst_share (expConst (V_data 0)))
      (sepconj 
         (points2 (expConst (V_addr 1)) fst_share (expConst (V_data 0)))
      (sepconj
         (points2 (expConst (V_addr 4)) snd_share (expConst (V_data 0)))
      (sepconj
         (points2 (expConst (V_addr 3)) snd_share (expConst (V_data 0)))
      (sepconj
         (points2 (expConst (V_addr 2)) snd_share (expConst (V_data 0)))
         (points2 (expConst (V_addr 1)) snd_share (expConst (V_data 0)))))))))).
  do 2 rewrite emp_simpl.
  repeat rewrite sc_assoc.
  do 2 (rewrite (sc_comm _ (barrier_assert _ snd_share _))).
  repeat(
    rewrite <- (sc_assoc _ (barrier_assert _ snd_share _) _);
    (rewrite (sc_comm _ (barrier_assert _ snd_share _)));
    rewrite (sc_assoc (barrier_assert _ snd_share _) _ _)).
  repeat (
    rewrite <- (sc_assoc _ (barrier_assert _ fst_share _) _);
    (rewrite (sc_comm _ (barrier_assert _ fst_share _)));
    rewrite (sc_assoc (barrier_assert _ fst_share _) _ _)).
  do 2 rewrite <- (sc_assoc (barrier_assert _ fst_share _) _ _).
  do 2 rewrite (barrier_assert_split _ _ _ pfullshare _ fstsndfull).
  split; trivial.
  do 3 apply sep_eq.
  repeat (
    rewrite <- (sc_assoc _ (points2 (expConst (V_addr 3)) _ _) _);
    (rewrite (sc_comm _ (points2 (expConst (V_addr 3)) _ _)));
    rewrite (sc_assoc (points2 (expConst (V_addr 3)) _ _) _ _)).
  apply sep_eq.
  repeat (
    rewrite <- (sc_assoc _ (points2 (expConst (V_addr 4)) _ _) _);
    (rewrite (sc_comm _ (points2 (expConst (V_addr 4)) _ _)));
    rewrite (sc_assoc (points2 (expConst (V_addr 4)) _ _) _ _)).
  apply sep_eq.
  rewrite <- (sc_assoc _ (points2 (expConst (V_addr 1)) fst_share _) _).
  (rewrite (sc_comm _ (points2 (expConst (V_addr 1)) fst_share _))).
  rewrite (sc_assoc (points2 (expConst (V_addr 1)) fst_share _) _ _).
  do 2 rewrite <- (points2_split _ _ _ pfullshare _ fstsndfull).
  repeat rewrite sc_assoc.
  apply sep_eq.
  rewrite <- (sc_assoc _ (points2 (expConst (V_addr 2)) fst_share _) _).
  (rewrite (sc_comm _ (points2 (expConst (V_addr 2)) fst_share _))).
  rewrite (sc_assoc (points2 (expConst (V_addr 2)) fst_share _) _ _).
  apply sep_eq.
  rewrite sc_comm.
  trivial.
Qed.

Program Definition mv03: BarMoveList := barMoveList  3 1 0 mv03_pps 2 _.
Next Obligation.
  unfold moves_wf.
   split;simpl.
   repeat intro.
   unfold mv01_pps in H.
   LEM (n=0).
   subst n.
   inversion H;subst.
   clear H.
   split.
 
   (*ubi P*)
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_barrier_assert.

 (*ubi Q*)
   split.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_barrier_assert.

  (*precise P *)
   split.
   apply precise_sep. apply precise_points2.
   apply precise_sep. apply precise_points2.
   apply precise_sep. apply precise_points2.
   apply precise_sep. apply precise_points2.

   apply precise_barrier.
  
  exists fst_share.
  repeat intro.
  rewrite  <- sc_assoc in H.
  rewrite sc_comm in H.
  do 3 destruct H.
  destruct H0.
  rewrite  <- sc_assoc in H0.
  rewrite sc_comm in H0.
  do 3 destruct H0.
  destruct H2.
  exists x1. 
  destruct (join_assoc _ _ _ _ _ H0 H) as [? [? ?]].
  exists x3.
  split; trivial.
  split; trivial.
  unfold Tru; trivial.

  LEM (n=1).
  (*second case *)
   subst n.
   clear H0.
   inversion H;subst.
   clear H.
   split.
 
 (*ubi P*)
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_barrier_assert.

 (*ubi Q*)
   split.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_barrier_assert.

  (*precise P *)
   split.
   apply precise_sep. apply precise_points2.
   apply precise_sep. apply precise_points2.
   apply precise_sep. apply precise_points2.
   apply precise_sep. apply precise_points2.

   apply precise_barrier.
  
  exists snd_share.
  repeat intro.
  rewrite  <- sc_assoc in H.
  rewrite sc_comm in H.
  do 3 destruct H.
  destruct H0.
  rewrite  <- sc_assoc in H0.
  rewrite sc_comm in H0.
  do 3 destruct H0.
  destruct H2.
  exists x1. 
  destruct (join_assoc _ _ _ _ _ H0 H) as [? [? ?]].
  exists x3.
  split; trivial.
  split; trivial.
  unfold Tru; trivial.

  (*by contradiction*)
  assert (n>=2) by omega.
  apply nth_error_bound in H.
  simpl in H.
  omegac.
  split; trivial.
  exists
      (sepconj
         (points2 (expConst (V_addr 4)) fst_share (expConst  (V_data 1)))
      (sepconj
         (points2 (expConst (V_addr 3)) fst_share (expConst (V_data 0)))
      (sepconj
         (points2 (expConst (V_addr 2)) fst_share (expConst (V_data 0)))
      (sepconj 
         (points2 (expConst (V_addr 1)) fst_share (expConst (V_data 0)))
      (sepconj
         (points2 (expConst (V_addr 4)) snd_share (expConst (V_data 1)))
      (sepconj
         (points2 (expConst (V_addr 3)) snd_share (expConst (V_data 0)))
      (sepconj
         (points2 (expConst (V_addr 2)) snd_share (expConst (V_data 0)))
         (points2 (expConst (V_addr 1)) snd_share (expConst (V_data 0)))))))))).
  do 2 rewrite emp_simpl.
  repeat rewrite sc_assoc.
  do 2 (rewrite (sc_comm _ (barrier_assert _ snd_share _))).
  repeat(
    rewrite <- (sc_assoc _ (barrier_assert _ snd_share _) _);
    (rewrite (sc_comm _ (barrier_assert _ snd_share _)));
    rewrite (sc_assoc (barrier_assert _ snd_share _) _ _)).
  repeat (
    rewrite <- (sc_assoc _ (barrier_assert _ fst_share _) _);
    (rewrite (sc_comm _ (barrier_assert _ fst_share _)));
    rewrite (sc_assoc (barrier_assert _ fst_share _) _ _)).
  do 2 rewrite <- (sc_assoc (barrier_assert _ fst_share _) _ _).
  do 2 rewrite (barrier_assert_split _ _ _ pfullshare _ fstsndfull).
  split; trivial.
  do 3 apply sep_eq.
  repeat (
    rewrite <- (sc_assoc _ (points2 (expConst (V_addr 3)) _ _) _);
    (rewrite (sc_comm _ (points2 (expConst (V_addr 3)) _ _)));
    rewrite (sc_assoc (points2 (expConst (V_addr 3)) _ _) _ _)).
  apply sep_eq.
  repeat (
    rewrite <- (sc_assoc _ (points2 (expConst (V_addr 4)) _ _) _);
    (rewrite (sc_comm _ (points2 (expConst (V_addr 4)) _ _)));
    rewrite (sc_assoc (points2 (expConst (V_addr 4)) _ _) _ _)).
  apply sep_eq.
  rewrite <- (sc_assoc _ (points2 (expConst (V_addr 1)) fst_share _) _).
  (rewrite (sc_comm _ (points2 (expConst (V_addr 1)) fst_share _))).
  rewrite (sc_assoc (points2 (expConst (V_addr 1)) fst_share _) _ _).
  do 2 rewrite <- (points2_split _ _ _ pfullshare _ fstsndfull).
  repeat rewrite sc_assoc.
  apply sep_eq.
  rewrite <- (sc_assoc _ (points2 (expConst (V_addr 2)) fst_share _) _).
  (rewrite (sc_comm _ (points2 (expConst (V_addr 2)) fst_share _))).
  rewrite (sc_assoc (points2 (expConst (V_addr 2)) fst_share _) _ _).
  apply sep_eq.
  rewrite sc_comm.
  trivial.
Qed.

Program Definition mv12: BarMoveList := barMoveList  2 1 1 mv12_pps 2 _ .
Next Obligation.
   unfold moves_wf.
   split;simpl.
   repeat intro.
   unfold mv01_pps in H.
   LEM (n=0).
   subst n.
   inversion H;subst.
   clear H.
   split.
 
   (*ubi P*)
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_barrier_assert.

 (*ubi Q*)
   split.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_barrier_assert.

  (*precise P *)
   split.
   apply precise_sep. apply precise_points2.
   apply precise_sep. apply precise_points2.
   apply precise_sep. apply precise_points2.

   apply precise_barrier.
  
  exists fst_share.
  repeat intro.
  rewrite  <- sc_assoc in H.
  rewrite sc_comm in H.
  do 3 destruct H.
  destruct H0.
  rewrite sc_comm in H0.
  do 3 destruct H0.
  destruct H2.
  exists x1. 
  destruct (join_assoc _ _ _ _ _ H0 H) as [? [? ?]].
  exists x3.
  split; trivial.
  split; trivial.
  unfold Tru; trivial.

  LEM (n=1).
  (*second case *)
   subst n.
   clear H0.
   inversion H;subst.
   clear H.
   split.
 
 (*ubi P*)
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_barrier_assert.

 (*ubi Q*)
   split.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_barrier_assert.

  (*precise P *)
   split.
   apply precise_sep. apply precise_points2.
   apply precise_sep. apply precise_points2.
   apply precise_sep. apply precise_points2.

   apply precise_barrier.
  
  exists snd_share.
  repeat intro.
  rewrite  <- sc_assoc in H.
  rewrite sc_comm in H.
  do 3 destruct H.
  destruct H0.
  rewrite sc_comm in H0.
  do 3 destruct H0.
  destruct H2.
  exists x1. 
  destruct (join_assoc _ _ _ _ _ H0 H) as [? [? ?]].
  exists x3.
  split; trivial.
  split; trivial.
  unfold Tru; trivial.

  (*by contradiction*)
  assert (n>=2) by omega.
  apply nth_error_bound in H.
  simpl in H.
  omegac.
  split; trivial.
  exists
      (sepconj
         (points2 (expConst (V_addr 4)) fst_share (expConst  (V_data 0)))
      (sepconj
         (points2 (expConst (V_addr 3)) fst_share (expConst (V_data 0)))
      (sepconj 
         (points2 (expConst (V_addr 1)) pfullshare (expConst (V_data 0)))
      (sepconj
         (points2 (expConst (V_addr 4)) snd_share (expConst (V_data 0)))
      (sepconj
         (points2 (expConst (V_addr 3)) snd_share (expConst (V_data 0)))
         (points2 (expConst (V_addr 2)) pfullshare (expConst (V_data 0)))))))).
  do 2 rewrite emp_simpl.
  repeat rewrite sc_assoc.
  do 2 (rewrite (sc_comm _ (barrier_assert _ snd_share _))).
  repeat(
    rewrite <- (sc_assoc _ (barrier_assert _ snd_share _) _);
    (rewrite (sc_comm _ (barrier_assert _ snd_share _)));
    rewrite (sc_assoc (barrier_assert _ snd_share _) _ _)).
  repeat (
    rewrite <- (sc_assoc _ (barrier_assert _ fst_share _) _);
    (rewrite (sc_comm _ (barrier_assert _ fst_share _)));
    rewrite (sc_assoc (barrier_assert _ fst_share _) _ _)).
  do 2 rewrite <- (sc_assoc (barrier_assert _ fst_share _) _ _).
  do 2 rewrite (barrier_assert_split _ _ _ pfullshare _ fstsndfull).
  split; trivial.
  do 1 apply sep_eq.
  do 6  (rewrite <- (sc_assoc _ (points2 (expConst (V_addr 3)) _ _) _);
    (rewrite (sc_comm _ (points2 (expConst (V_addr 3)) _ _)));
    rewrite (sc_assoc (points2 (expConst (V_addr 3)) _ _) _ _)).
  rewrite <- (points2_split _ _ _ pfullshare _ fstsndfull).
  repeat rewrite sc_assoc.
  do 2 apply sep_eq.
     rewrite <- (sc_assoc _ (points2 (expConst (V_addr 4)) snd_share _) _);
    (rewrite (sc_comm _ (points2 (expConst (V_addr 4)) snd_share _)));
    rewrite (sc_assoc (points2 (expConst (V_addr 4)) snd_share _) _ _).

    (rewrite (sc_comm _ (points2 (expConst (V_addr 4)) pfullshare _))).
  do 3 (
    rewrite <- (sc_assoc _ (points2 (expConst (V_addr 4)) pfullshare _) _);
    (rewrite (sc_comm _ (points2 (expConst (V_addr 4)) pfullshare _)));
    rewrite (sc_assoc (points2 (expConst (V_addr 4)) pfullshare _) _ _)).
    rewrite <- (points2_split _ _ _ pfullshare _ fstsndfull).
    repeat rewrite sc_assoc. apply sep_eq. apply sep_eq.


     rewrite <- (sc_assoc _ (points2 (expConst (V_addr 1)) snd_share _) _);
    (rewrite (sc_comm _ (points2 (expConst (V_addr 1)) snd_share _)));
    rewrite (sc_assoc (points2 (expConst (V_addr 1)) snd_share _) _ _).
    rewrite <- (points2_split _ _ _ pfullshare _ fstsndfull).
    repeat rewrite sc_assoc. apply sep_eq. apply sep_eq.
    rewrite <- (points2_split _ _ _ pfullshare _ fstsndfull).
    trivial.
Qed.

         
Program Definition mv21: BarMoveList := barMoveList  1 1 2 mv21_pps 2 _ .
Next Obligation.
   unfold moves_wf.
   split;simpl.
   repeat intro.
   unfold mv01_pps in H.
   LEM (n=0).
   subst n.
   inversion H;subst.
   clear H.
   split.
 
   (*ubi P*)
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_barrier_assert.

 (*ubi Q*)
   split.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_barrier_assert.

  (*precise P *)
   split.
   apply precise_sep. apply precise_points2.
   apply precise_sep. apply precise_points2.
   apply precise_sep. apply precise_points2.

   apply precise_barrier.
  
  exists fst_share.
  repeat intro.
  rewrite  <- sc_assoc in H.
  rewrite sc_comm in H.
  do 3 destruct H.
  destruct H0.
  rewrite sc_comm in H0.
  do 3 destruct H0.
  destruct H2.
  exists x1. 
  destruct (join_assoc _ _ _ _ _ H0 H) as [? [? ?]].
  exists x3.
  split; trivial.
  split; trivial.
  unfold Tru; trivial.

  LEM (n=1).
  (*second case *)
   subst n.
   clear H0.
   inversion H;subst.
   clear H.
   split.
 
 (*ubi P*)
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_barrier_assert.

 (*ubi Q*)
   split.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_sep . apply ubiquitous_points2_const.
   apply ubiquitous_barrier_assert.

  (*precise P *)
   split.
   apply precise_sep. apply precise_points2.
   apply precise_sep. apply precise_points2.
   apply precise_sep. apply precise_points2.

   apply precise_barrier.
  
  exists snd_share.
  repeat intro.
  rewrite  <- sc_assoc in H.
  rewrite sc_comm in H.
  do 3 destruct H.
  destruct H0.
  rewrite sc_comm in H0.
  do 3 destruct H0.
  destruct H2.
  exists x1. 
  destruct (join_assoc _ _ _ _ _ H0 H) as [? [? ?]].
  exists x3.
  split; trivial.
  split; trivial.
  unfold Tru; trivial.

  (*by contradiction*)
  assert (n>=2) by omega.
  apply nth_error_bound in H.
  simpl in H.
  omegac.
  split; trivial.
  exists
      (sepconj 
         (points2 (expConst (V_addr 1)) fst_share (expConst (V_data 0)))
      (sepconj
         (points2 (expConst (V_addr 2)) fst_share (expConst (V_data 0)))
      (sepconj
         (points2 (expConst (V_addr 3)) pfullshare (expConst (V_data 0)))
      (sepconj 
         (points2 (expConst (V_addr 1)) snd_share (expConst (V_data 0)))
      (sepconj
         (points2 (expConst (V_addr 2)) snd_share (expConst (V_data 0)))
         (points2 (expConst (V_addr 4)) pfullshare (expConst (V_data 0)))))))).
do 2 rewrite emp_simpl.
  repeat rewrite sc_assoc.
  do 2 (rewrite (sc_comm _ (barrier_assert _ snd_share _))).
  repeat(
    rewrite <- (sc_assoc _ (barrier_assert _ snd_share _) _);
    (rewrite (sc_comm _ (barrier_assert _ snd_share _)));
    rewrite (sc_assoc (barrier_assert _ snd_share _) _ _)).
  repeat (
    rewrite <- (sc_assoc _ (barrier_assert _ fst_share _) _);
    (rewrite (sc_comm _ (barrier_assert _ fst_share _)));
    rewrite (sc_assoc (barrier_assert _ fst_share _) _ _)).
  do 2 rewrite <- (sc_assoc (barrier_assert _ fst_share _) _ _).
  do 2 rewrite (barrier_assert_split _ _ _ pfullshare _ fstsndfull).
  split;trivial.  apply sep_eq. 
    (rewrite (sc_comm _ (points2 (expConst (V_addr 4)) pfullshare _))).
  do 2 (
    rewrite <- (sc_assoc _ (points2 (expConst (V_addr 1)) _ _) _);
    (rewrite (sc_comm _ (points2 (expConst (V_addr 1)) _ _)));
    rewrite (sc_assoc (points2 (expConst (V_addr 1)) _ _) _ _)).
  do 2 (
    rewrite <- (sc_assoc _ (points2 (expConst (V_addr 1)) snd_share _) _);
    (rewrite (sc_comm _ (points2 (expConst (V_addr 1)) snd_share _)));
    rewrite (sc_assoc (points2 (expConst (V_addr 1)) snd_share _) _ _)).
    rewrite <- (points2_split _ _ _ pfullshare _ fstsndfull).
    repeat rewrite sc_assoc.
    apply sep_eq. apply sep_eq.
    (rewrite (sc_comm _ (points2 (expConst (V_addr 2)) snd_share _))).
  do 1 (
    rewrite <- (sc_assoc _ (points2 (expConst (V_addr 2)) snd_share _) _);
    (rewrite (sc_comm _ (points2 (expConst (V_addr 2)) snd_share _)));
    rewrite (sc_assoc (points2 (expConst (V_addr 2)) snd_share _) _ _)).
    (rewrite (sc_comm _ (points2 (expConst (V_addr 2)) pfullshare _))).
  do 3 (
    rewrite <- (sc_assoc _ (points2 (expConst (V_addr 2)) pfullshare _) _);
    (rewrite (sc_comm _ (points2 (expConst (V_addr 2)) pfullshare _)));
    rewrite (sc_assoc (points2 (expConst (V_addr 2)) pfullshare _) _ _)).
    rewrite <- (points2_split _ _ _ pfullshare _ fstsndfull).
    repeat rewrite sc_assoc. apply sep_eq. apply sep_eq.
  do 1 (
    rewrite <- (sc_assoc _ (points2 (expConst (V_addr 3)) fst_share _) _);
    (rewrite (sc_comm _ (points2 (expConst (V_addr 3)) fst_share _)));
    rewrite (sc_assoc (points2 (expConst (V_addr 3)) fst_share _) _ _)).
    (rewrite (sc_comm _ (points2 (expConst (V_addr 3)) snd_share _))).
    rewrite <- (sc_assoc _ (points2 (expConst (V_addr 3)) snd_share _) _);
    (rewrite (sc_comm _ (points2 (expConst (V_addr 3)) snd_share _)));
    rewrite (sc_assoc (points2 (expConst (V_addr 3)) snd_share _) _ _).
    rewrite <- (points2_split _ _ _ pfullshare _ fstsndfull).
    repeat rewrite sc_assoc. apply sep_eq. apply sep_eq.
    rewrite <- (points2_split _ _ _ pfullshare _ fstsndfull).
    trivial.         
Qed.

Lemma lookup_move'_fun : forall dl rd rm pre post pre' post',
  lookup_move' dl rd rm pre post ->
  lookup_move' dl rd rm pre' post' ->
  pre = pre' /\ post = post'.
Proof.
  unfold lookup_move'.
  intros.
  icase (nth_error dl rd).
  icase b.
  icase (nth_error bml_moves rm).
  destruct p.
  destruct H.
  destruct H0.
  split; congruence.
Qed.

Lemma contra_and : forall  x sh1 sh2 x1 x2 e1 e2 y,
    x1<> x2 -> (and
     (sepconj
           (points2 (expConst (V_addr x)) sh1 (expConst(V_data x1))) e1)
     (sepconj
           (points2 (expConst (V_addr x)) sh2 (expConst(V_data x2))) e2)) y -> False.
Proof.
      repeat intro.
    destruct H0. 
    do 3 destruct H0. destruct H2.
    do 3 destruct H1. destruct H4.
    destruct x4 as [[? [? ?]] ?].
    destruct x0 as [[? [? ?]] ?].
    inversion H2;subst. destruct H7. 
    inversion H4;subst. destruct H10.
    unfold st_hf, st_stk,st_hp,fst,snd in *.
    clear -H1 H0 H7 H10 H.
    unfold evalExpr in *.
    do 1 (destruct H1; destruct H0).
    destruct H0; destruct H1.
    destruct H4. destruct H5. unfold fst, snd in *. 
    clear H3 H0 H4 H1 H2 H5.
    destruct x3 as [[? [? ?]] ?].
    destruct y as [[? [? ?]] ?].
    destruct x5 as [[? [? ?]] ?].
    spec H8 x.
    spec H6 x.
    rewrite H7 in H6.
    rewrite H10 in H8.
    simpl in H8, H6.

    inversion H6;subst.
    unfold res_builder in H1.
    destruct sh1 as [? ?].
    inversion H1.
    rewrite <- H2 in H6.
    rewrite <- H3 in H8.
    rewrite <- H3 in H6.
    inversion H8;subst.
    destruct sh2 as [? ?].
    inversion H1.
    clear -H5 H.
    unfold res_builder in *.
    destruct sh2 as [? ?].
    destruct sh1 as [? ?].
    inversion H5;subst. contradiction H;trivial. 
    clear -H5 H0 H1 H4 H.
    destruct z.
    destruct x0.
    destruct y.
    destruct sh2 as [? ?].
    destruct sh1 as [? ?].
    destruct x4 as [? ?].
    inversion H4;subst.
    inversion H0;subst.
    inversion H1;subst.
    simpl in H5.
    clear -H5 H.
    destruct H5.
    destruct H0.
    unfold fst,snd in *.
    subst v. inversion H2;subst.
    contradiction H;trivial.
    rewrite <- H2 in  H8.
    inversion H8;subst.
    destruct sh2 as [? ?].
    inversion H5.
    rewrite <- H9 in  H8.
    rewrite <- H2 in H6.
    rewrite <- H11 in H6.
    clear -H6 H.
    inversion H6.
    destruct sh1 as [? ?].
    inversion H1.
    destruct sh1 as [? ?].
    destruct sh2 as [? ?].
    inversion H3;subst. contradiction H;trivial.
    destruct sh1 as [? ?].
    destruct sh2 as [? ?].
    unfold res_builder in *.
    inversion H2;subst.
    inversion H0;subst.
    destruct y.
    clear -H3 H.
    destruct H3.
    destruct H0.
    rewrite H2 in H0.
    inversion H0;subst.
    contradiction H;trivial.

    unfold res_builder in H4.
    destruct sh2 as [? ?].
    inversion H4;subst.
    unfold res_builder in H0.
    destruct sh1 as [? ?].
    inversion H0;subst.
    destruct y.
    destruct z.
    destruct y0.
    clear -H11 H3 H.
    destruct H11.
    destruct H0.
    destruct H3.
    destruct H3.
    destruct x6 as [? ?]. destruct x0 as [? ?]. destruct x5 as [? ?]. 
    unfold fst,snd in * . subst v v0 v1. 
    inversion H5;subst. contradiction H;trivial.
Qed.


Program Definition st0: BarStateDef := barStateDef 1 0 (mv01::mv03::nil) 2  _ .
Next Obligation.
  split.
  repeat intro.
  assert ((i = 0 /\ j = 1) \/ (j = 0 /\ i = 1)).
    destruct i.
    icase j.
    contradiction H; trivial.
    icase j.
    red in H1.
    icase j.
    icase i.
    icase j.
    icase j.
    contradiction H; trivial.
    red in H1.
    icase j.
    red in H0.
    icase i.

  unfold Fls.
  extensionality.
  apply prop_ext. split. Focus 2. intro. contradiction H3.
  destruct H2; destruct H2; subst; unfold lookup_move' in *; simpl in H1, H0.
  remember (nth_error mv03_pps mj).
  remember (nth_error mv01_pps mi).
  icase e.
  icase e0.
  destruct p.
  destruct p0.
  destruct H1.
  destruct H0.
  subst.
  clear H.
  icase mj.
  icase mi.
  simpl nth_error in Heqe. inversion Heqe;subst.
  simpl nth_error in Heqe0. inversion Heqe0;subst.
  clear Heqe Heqe0.
    repeat rewrite  sc_assoc . apply contra_and. trivial.

  icase mi.
  simpl nth_error in Heqe. inversion Heqe;subst.
  simpl nth_error in Heqe0. inversion Heqe0;subst.
  clear Heqe Heqe0.
    repeat rewrite  sc_assoc . apply contra_and. trivial.

  icase mi.
  icase mj.
  icase mi.
  simpl nth_error in Heqe. inversion Heqe;subst.
  simpl nth_error in Heqe0. inversion Heqe0;subst.
  clear Heqe Heqe0.    
    repeat rewrite  sc_assoc . apply contra_and. trivial.

  icase mi.
  simpl nth_error in Heqe. inversion Heqe;subst.
  simpl nth_error in Heqe0. inversion Heqe0;subst.
  clear Heqe Heqe0.
    repeat rewrite  sc_assoc . apply contra_and. trivial. 
  icase mi.
  icase mj.
  
  clear H.
  icase mi.
  icase mj.
  simpl nth_error in H0. inversion H0;subst.
  simpl nth_error in H1. inversion H1;subst.
  clear H1 H0.
    repeat rewrite  sc_assoc . apply contra_and. auto.
  icase mj.
  simpl nth_error in H0. inversion H0;subst.
  simpl nth_error in H1. inversion H1;subst.
  clear H1 H0.
    repeat rewrite  sc_assoc . apply contra_and. auto.
  icase mj.
  icase mi.
  icase mj.
  simpl nth_error in H0. inversion H0;subst.
  simpl nth_error in H1. inversion H1;subst.
  clear H1 H0.
    repeat rewrite  sc_assoc . apply contra_and. auto.
  icase mj.
  simpl nth_error in H0. inversion H0;subst.
  simpl nth_error in H1. inversion H1;subst.
  clear H1 H0.
    repeat rewrite  sc_assoc . apply contra_and. auto.
  icase mj.
  icase mi.

  repeat intro.
  LEM (i=0);subst.
  inversion H;subst.
  unfold mv01,bml_cs,bml_bn,bml_limit.
  split. trivial. split; trivial.
  LEM (i=1);subst.
  inversion H;subst.
  unfold mv03,bml_cs,bml_bn,bml_limit.
  split. trivial. split; trivial.
  apply nth_error_bound in H.
  simpl in H.
  omegac.
Qed.

Program Definition st1: BarStateDef := barStateDef 1 1 (mv12::nil) 2  _.
Next Obligation.
  split.
  repeat intro.
  destruct i.
  icase j.
  contradiction H;trivial.
  icase j.
  icase i.
  repeat intro.
  LEM (i=0);subst.
  inversion H;subst.
  unfold mv01,bml_cs,bml_bn,bml_limit.
  split. trivial. split; trivial.
  apply nth_error_bound in H.
  simpl in H.
  omegac.
Qed.

Program Definition st2: BarStateDef := barStateDef 1 2 (mv21::nil) 2  _.
Next Obligation.
  split.
  repeat intro.
  destruct i.
  icase j.
  contradiction H;trivial.
  icase j.
  icase i.
  repeat intro.
  LEM (i=0);subst.
  inversion H;subst.
  unfold mv01,bml_cs,bml_bn,bml_limit.
  split. trivial. split; trivial.
  apply nth_error_bound in H.
  simpl in H.
  omegac.
Qed.

Program Definition st3: BarStateDef := barStateDef 1 3 nil 2  _.
Next Obligation.
 split.
 repeat intro.
 red in H0, H1.
 icase i.
 repeat intro.
 icase i.
Qed.

Program Definition theB: BarDef := barDef  1 2 (st0::st1::st2::st3::nil)  _.
Next Obligation.
  split.
  assert (2>0) by omega.
  trivial.
  repeat intro.
  LEM (i=0);subst.
  inversion H;subst.
  unfold st0, bsd_limit, bsd_bn, bsd_cs.
  split;trivial. split;trivial.
  LEM (i=1); subst.
  inversion H;subst.
  split;trivial. split;trivial.
  LEM (i=2);subst.
  inversion H;subst.
  split;trivial. split;trivial.
  LEM (i=3);subst.
  inversion H;subst.
  split;trivial. split;trivial.
  apply nth_error_bound in H.
  simpl in H.
  omegac.
Qed.
